#Test Name: TransientFrictionWaterlayer3D
import numpy as np
from model import *
from socket import gethostname
from triangle import *
from setmask import *
from parameterize import *
from setflowequation import *
from solve import *
from frictionwaterlayer import *

md = triangle(model(),'../Exp/Square.exp',150000.)
md = setmask(md,'../Exp/SquareShelf.exp','')
md = parameterize(md,'../Par/SquareSheetShelf.py')
md = md.extrude(4,1.)
md = setflowequation(md,'HO','all')
md.friction = frictionwaterlayer(md)
md.friction.water_layer = np.zeros((md.mesh.numberofvertices+1,2))
md.friction.water_layer[:,1] = 1.
md.friction.water_layer[md.mesh.numberofvertices,:] = [1.,2.]
md.friction.f = 0.8
md.groundingline.melt_interpolation='SubelementMelt2'
md.cluster = generic('name',gethostname(),'np',3)
md = solve(md,'Transient')

#Fields and tolerances to track changes
field_names =['Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1',
	      'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2',
	      'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3']
field_tolerances = [1e-09,1e-09,1e-09,1e-09,1e-09,1e-09,1e-09,
		    1e-09,1e-09,1e-09,1e-09,1e-09,1e-09,1e-09,
		    1e-09,1e-09,1e-09,1e-09,1e-09,1e-09,1e-09]
field_values = [
	md.results.TransientSolution[0].Vx,
	md.results.TransientSolution[0].Vy,
	md.results.TransientSolution[0].Vel,
	md.results.TransientSolution[0].Pressure,
	md.results.TransientSolution[0].Base,
	md.results.TransientSolution[0].Surface,
	md.results.TransientSolution[0].Thickness,
	md.results.TransientSolution[1].Vx,
	md.results.TransientSolution[1].Vy,
	md.results.TransientSolution[1].Vel,
	md.results.TransientSolution[1].Pressure,
	md.results.TransientSolution[1].Base,
	md.results.TransientSolution[1].Surface,
	md.results.TransientSolution[1].Thickness,
	md.results.TransientSolution[2].Vx,
	md.results.TransientSolution[2].Vy,
	md.results.TransientSolution[2].Vel,
	md.results.TransientSolution[2].Pressure,
	md.results.TransientSolution[2].Base,
	md.results.TransientSolution[2].Surface,
	md.results.TransientSolution[2].Thickness
	]
